Index: sansview/perspectives/fitting/fitting.py
===================================================================
--- sansview/perspectives/fitting/fitting.py	(revision bb18ef1c74ed79eb0630f198735ad2b14e7913ab)
+++ sansview/perspectives/fitting/fitting.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -671,4 +715,20 @@
         self._on_change_engine('scipy')
        
+    def _on_slicer_event(self, event):
+        """
+            Receive a panel as event and send it to guiframe 
+            @param event: event containing a panel
+        """
+        if event.panel!=None:
+            new_panel = event.panel
+            # Set group ID if available
+            event_id = self.parent.popup_panel(new_panel)
+            self.menu1.Append(event_id, new_panel.window_caption, 
+                             "Show %s plot panel" % new_panel.window_caption)
+            # Set UID to allow us to reference the panel later
+            new_panel.uid = event_id
+            new_panel
+            self.mypanels.append(new_panel) 
+        return    
     
     def _on_change_engine(self, engine='park'):
@@ -686,8 +746,8 @@
             @param evt: wx.combobox event
         """
-       
         model = evt.model
-        name = evt.name
-       
+        if model ==None:
+            return
+        name = model.name
         sim_page=self.sim_page
         current_pg = self.fit_panel.get_current_page() 
@@ -711,170 +771,12 @@
             self.page_finder[current_pg].set_model(model,M_name)
             
-                
             # save model name
-            self.plot_helper(currpage= current_pg,qmin= None,qmax= None)
+            self.draw_model( model=model, data= metadata)
+            
             if self.sim_page!=None:
                 self.sim_page.add_model(self.page_finder)
         
         
-        
-    def  set_smearer(self,smearer):
-        """
-            Get a smear object and store it to a fit problem
-            @param smearer: smear object to allow smearing data
-        """   
-        current_pg=self.fit_panel.get_current_page()
-        self.page_finder[current_pg].set_smearer(smearer)
-         
-         
-    def redraw_model(self,qmin= None,qmax= None):
-        """
-            Draw a theory according to model changes or data range.
-            @param qmin: the minimum value plotted for theory
-            @param qmax: the maximum value plotted for theory
-        """
-        current_pg=self.fit_panel.get_current_page()
-        for page, value in self.page_finder.iteritems():
-            if page ==current_pg :
-                break 
-        self.plot_helper(currpage=page,qmin= qmin,qmax= qmax)
-        
-        
-        
-    def plot_helper(self,currpage, qmin=None,qmax=None,
-                    ymin=None,ymax=None, xmin=None, xmax=None,title=None ):
-        """
-            Plot a theory given a model and data
-            @param model: the model from where the theory is derived
-            @param currpage: page in a dictionary referring to some data
-        """
-        if self.fit_panel.GetPageCount() >1:
-            for page in self.page_finder.iterkeys():
-                if  page == currpage :  
-                    data= self.page_finder[page].get_plotted_data()
-                    list= self.page_finder[page].get_model()
-                    smearer = self.page_finder[page].get_smearer()
-                    model = list[0]
-                    break 
-            ## create Model 1D
-            if data != None and data.__class__.__name__ != 'Data2D':
-                x= numpy.zeros(len(data.x))  
-                y= numpy.zeros(len(data.y)) 
-                
-                theory = Theory1D(x=x, y=y)
-                theory.name = model.name
-                if hasattr(data ,"group_id"):
-                    theory.group_id = data.group_id
-                theory.id = "Model"
-                
-                x_name, x_units = data.get_xaxis() 
-                y_name, y_units = data.get_yaxis() 
-                theory.xaxis(x_name, x_units)
-                theory.yaxis(y_name, y_units)
-                if qmin == None :
-                    qmin = min(data.x)
-                if qmax == None :
-                    qmax = max(data.x)
-                
-                j=0
-                try:
-                    tempx = qmin
-                    tempy = model.run(qmin)
-                    theory.x[j]=tempx
-                    theory.y[j]=tempy
-                    j+=1
-                except :
-                        wx.PostEvent(self.parent, StatusEvent(status="fitting \
-                        skipping point x %g %s" %(qmin, sys.exc_value)))
-                           
-                for i in range(len(data.x)):
-                    try:
-                        if data.x[i]> qmin and data.x[i]< qmax: 
-                            tempx = data.x[i]
-                            tempy = model.run(tempx)
-                            
-                            if j< i:
-                                theory.x[j]=tempx 
-                                theory.y[j]=tempy
-                                j+=1
-                           
-                    except:
-                        wx.PostEvent(self.parent, StatusEvent(status="fitting \
-                        skipping point x %g %s" %(data.x[i], sys.exc_value)))   
-                try:
-                    tempx = qmax
-                    tempy = model.run(qmax)
-                
-                    theory.x[j]=tempx 
-                    theory.y[j]=tempy
-                    j+=1
-                except:
-                    wx.PostEvent(self.parent, StatusEvent(status="fitting \
-                        skipping point x %g %s" %(qmin, sys.exc_value)) )
-                
-                if smearer!=None:
-                    theory.y= smearer(theory.y)   
-                wx.PostEvent(self.parent, NewPlotEvent(plot=theory,
-                                                title=str(data.name)))
-            else:
-                ## create Model 2D
-                theory=Data2D(data.data, data.err_data)
-                theory.name= model.name
-                if title !=None:
-                    self.title = title
-                    theory.id= self.title
-                    theory.group_id= self.title+data.name
-                else:
-                    self.title= "Analytical model 2D "
-                    theory.id= "Model"
-                    theory.group_id= "Model"+data.name
-                theory.x_bins= data.x_bins
-                theory.y_bins= data.y_bins
-                tempy=[]
-                
-                if qmin==None:
-                    qmin=0
-                if qmax==None:
-                    x= math.pow(max(math.fabs(data.xmax),math.fabs(data.xmin)),2)
-                    y= math.pow(max(math.fabs(data.ymax),math.fabs(data.ymin)),2)
-                    qmax=math.sqrt( x+y )
-                    
-                if ymin==None:
-                    ymin=data.ymin
-                if ymax==None:
-                    ymax=data.ymax
-                if xmin ==None:
-                    xmin=data.xmin
-                if xmax==None:
-                    xmax=data.xmax      
-                                  
-                theory.data = numpy.zeros((len(data.y_bins),len(data.x_bins)))
-                for j in range(len(data.y_bins)):
-                    for i in range(len(data.x_bins)):
-                        tempqij=math.sqrt(( math.pow(data.y_bins[j],2)\
-                                           +math.pow(data.x_bins[i],2) ))
-                        
-                        if tempqij>= qmin and tempqij<= qmax: 
-                            theory.data[j][i] = model.runXY([data.y_bins[j],
-                                                             data.x_bins[i]] )
-                        else:
-                            ## Later, We need to decide which of  0 and None is better.
-                            theory.data[j][i]=0 
-             
-                theory.detector= data.detector
-                theory.source= data.source
-                ## qmin, qmax will used later to define q range.
-                theory.qmin= qmin
-                theory.qmax= qmax
-                ## plot boundaries
-                theory.ymin= ymin
-                theory.ymax= ymax
-                theory.xmin= xmin
-                theory.xmax= xmax
-        
-                wx.PostEvent(self.parent, NewPlotEvent(plot=theory,
-                                                title=self.title +str(data.name)))
-        
-        
+  
     def _on_model_menu(self, evt):
         """
@@ -893,90 +795,8 @@
         self.fit_panel.add_model_page(model,description,name,topmenu=True)
     
-    def complete1D_from_data(self, output,model, data, x, elapsed, name):
-        """
-             plot model 1D with data info 
-        """
-        y= output
-        x= data.x
-        theory = Theory1D(x=x, y=y)
-        theory.name = model.name
-        theory.group_id = data.group_id
-        theory.id = "Model"
-        
-        x_name, x_units = data.get_xaxis() 
-        y_name, y_units = data.get_yaxis() 
-        theory.xaxis(x_name, x_units)
-        theory.yaxis(y_name, y_units)
-        wx.PostEvent(self.parent, NewPlotEvent(plot=theory,
-                                                title=str(data.name)))
-        
-    def draw_model1D_from_Data(self, data, model,name=None,
-                                qmin=None, qmax=None, smearer= None):
-        """
-            Draw model 1D from loaded data1D
-            @param data: loaded data
-            @param model: the model to plot
-        """
-        x = data.x
-        self.model= model
-        if qmin == None :
-           qmin = min(data.x)
-        if qmax == None :
-           qmax = max(data.x)
-        if name ==None:
-            name=model.name
-        try:
-            from model_thread import Calc1D
-            ## If a thread is already started, stop it
-            if self.calc_thread != None and self.calc_thread.isrunning():
-                self.calc_thread.stop()
-            self.calc_thread = Calc1D( x= x,
-                                      model= self.model, 
-                                       qmin= qmin,
-                                       qmax= qmax,
-                                       name= name,
-                                       smearer= smearer,
-                            completefn= self.complete1D_from_data,
-                            updatefn= self.update1D)
-            self.calc_thread.queue()
-            
-        except:
-            msg= " Error occurred when drawing %s Model 1D: "%self.model.name
-            msg+= " %s"%sys.exc_value
-            wx.PostEvent( self.parent, StatusEvent(status= msg ))
-            return  
-            
-    def draw_model(self, model, name, data= None, description= None,
-                   enable1D= True, enable2D= False,
-                   qmin= DEFAULT_QMIN, qmax= DEFAULT_QMAX, qstep= DEFAULT_NPTS):
-        """
-             Draw model.
-             @param model: the model to draw
-             @param name: the name of the model to draw
-             @param data: the data on which the model is based to be drawn
-             @param description: model's description
-             @param enable1D: if true enable drawing model 1D
-             @param enable2D: if true enable drawing model 2D
-             @param qmin:  Range's minimum value to draw model
-             @param qmax:  Range's maximum value to draw model
-             @param qstep: number of step to divide the x and y-axis
-             
-        """
-        ## draw model based on loaded data
-        if data !=None:
-            self.redraw_model(qmin,qmax)
-            return 
-        ## draw model 1D with no loaded data
-        self._draw_model1D(model,name,model.description, enable1D,qmin,qmax, qstep)
-        ## draw model 2D with no initial data
-        self._draw_model2D(model=model,
-                           description=model.description,
-                           enable2D= enable2D,
-                           qmin=qmin,
-                           qmax=qmax,
-                           qstep=qstep)
-        
-    
-    def update1D(self,x, output):
+   
+    
+    
+    def _update1D(self,x, output):
         """
             Update the output of plotting model 1D
@@ -984,98 +804,12 @@
         self.calc_thread.ready(1)
     
-    def complete1D(self, x,output, elapsed, name,data=None):
-        """
-            Complete plotting 1D data
-        """ 
-        try:
-            y = output
-            new_plot = Theory1D(x, y)
-            new_plot.name = name
-            new_plot.xaxis("\\rm{Q}", 'A^{-1}')
-            new_plot.yaxis("\\rm{Intensity} ","cm^{-1}")
-            new_plot.id ="Model"
-            new_plot.group_id ="Model"
-            # Pass the reset flag to let the plotting event handler
-            # know that we are replacing the whole plot
-            wx.PostEvent(self.parent, NewPlotEvent(plot=new_plot,
-                             title="Analytical model 1D ", reset=True ))
-            
-        except:
-            msg= " Error occurred when drawing %s Model 1D: "%new_plot.name
-            msg+= " %s"%sys.exc_value
-            wx.PostEvent( self.parent, StatusEvent(status= msg ))
-            return  
-        
-                 
-    def _draw_model1D(self, model, name, description= None, enable1D= True,
-                      qmin= DEFAULT_QMIN, qmax= DEFAULT_QMAX, qstep= DEFAULT_NPTS):
-        """
-            Draw model 1D between qmin and qmax value
-            @param model: the model to draw
-            @param name: the name of the model
-            @param description: descripion of the model as string
-            @param enable1D:  allow to draw model 1D if True  else False
-            @param qmin: the minimum value of the range to draw the model
-            @param qmax: the maximum value of the range to draw the model
-            @param qstep: the number of points to draw  
-        """
-        x=  numpy.linspace(start= qmin,
-                           stop= qmax,
-                           num= qstep,
-                           endpoint=True
-                           )      
-        self.model= model
-        if enable1D:
-            try:
-                from model_thread import Calc1D
-                ## If a thread is already started, stop it
-                if self.calc_thread != None and self.calc_thread.isrunning():
-                    self.calc_thread.stop()
-                self.calc_thread = Calc1D( x= x,
-                                          model= self.model, 
-                                           qmin= qmin,
-                                           qmax= qmax,
-                                           name= name,
-                                           data=None,
-                                        smearer=None,
-                                completefn= self.complete1D,
-                                updatefn= self.update1D)
-                self.calc_thread.queue()
-                
-            except:
-                msg= " Error occurred when drawing %s Model 1D: "%self.model.name
-                msg+= " %s"%sys.exc_value
-                wx.PostEvent( self.parent, StatusEvent(status= msg ))
-                return  
-                
-
-
-        
-    def update2D(self, output,time=None):
-        """
-            Update the output of plotting model
-        """
-        wx.PostEvent(self.parent, StatusEvent(status="Plot \
-        #updating ... ",type="update"))
-        self.calc_thread.ready(0.01)
-        
-        
-    def complete2D(self, output, elapsed, model, qmin, qmax,qstep=DEFAULT_NPTS):
-        """
-            Complete get the result of modelthread and create model 2D
-            that can be plot.
-        """
-        msg = "Calc complete !"
-        wx.PostEvent( self.parent, StatusEvent( status= msg , type="stop" ))
-    
-        data = output
-        temp= numpy.zeros(numpy.shape(data))
-        temp[temp==0]=1
-        theory= Data2D(image=data, err_image=temp)
-    
+    def _fill_default_model2D(self, theory, qmax,qstep, qmin=None):
+        """
+            fill Data2D with default value 
+            @param theory: Data2D to fill
+        """
         from DataLoader.data_info import Detector, Source
         
         detector = Detector()
-        theory.detector=[]
         theory.detector.append(detector) 
             
@@ -1083,6 +817,5 @@
         theory.source= Source()
         theory.source.wavelength=2*math.pi/1e+32
-        theory.x_bins =[]
-        theory.y_bins =[]
+      
         ## Create detector for Model 2D
         xmax=2*theory.detector[0].distance*math.atan(\
@@ -1114,5 +847,4 @@
             theory.y_bins.append(qy)
            
-        theory.name= model.name
         theory.group_id ="Model"
         theory.id ="Model"
@@ -1122,11 +854,115 @@
         theory.ymin= -qmax
         theory.ymax= qmax
+        
+        
+    def _get_plotting_info(self, data=None):
+        """
+            get plotting info from data if data !=None
+            else use some default
+        """
+        my_info = PlotInfo()
+        if data !=None:
+            if hasattr(data,"info"):
+                x_name, x_units = data.get_xaxis() 
+                y_name, y_units = data.get_yaxis() 
+                
+                my_info._xunit = x_units
+                my_info._xaxis = x_name
+                my_info._yunit = y_units
+                my_info._yaxis = y_name
+                
+            my_info.title= data.name
+            if hasattr(data, "info"):
+                my_info.info= data.info
+            if hasattr(data, "group_id"):
+                my_info.group_id= data.group_id
+            
+        return my_info
+                
+    def _complete1D(self, x,y, elapsed,model,data=None):
+        """
+            Complete plotting 1D data
+        """ 
+        try:
+            new_plot = Theory1D(x=x, y=y)
+            my_info = self._get_plotting_info( data)
+            new_plot.name = model.name
+            new_plot.id = my_info.id
+            new_plot.group_id = my_info.group_id
+            
+            new_plot.xaxis( my_info._xaxis,  my_info._xunit)
+            new_plot.yaxis( my_info._yaxis, my_info._yunit)
+            
+            # Pass the reset flag to let the plotting event handler
+            # know that we are replacing the whole plot
+            title= my_info.title
+            if title== None:
+                title="Analytical model 1D "
+                wx.PostEvent(self.parent, NewPlotEvent(plot=new_plot,
+                             title= str(title), reset=True ))
+            else:
+                wx.PostEvent(self.parent, NewPlotEvent(plot=new_plot,
+                             title= str(title)))
+            
+        except:
+            msg= " Error occurred when drawing %s Model 1D: "%new_plot.name
+            msg+= " %s"%sys.exc_value
+            wx.PostEvent( self.parent, StatusEvent(status= msg ))
+            return  
+        
+                 
+    
+        
+    def _update2D(self, output,time=None):
+        """
+            Update the output of plotting model
+        """
+        wx.PostEvent(self.parent, StatusEvent(status="Plot \
+        #updating ... ",type="update"))
+        self.calc_thread.ready(0.01)
+        
+        
+    def _complete2D(self, image,data, model,  elapsed,qmin, qmax,qstep=DEFAULT_NPTS):
+        """
+            Complete get the result of modelthread and create model 2D
+            that can be plot.
+        """
+        msg = "Calc complete !"
+        wx.PostEvent( self.parent, StatusEvent( status= msg , type="stop" ))
+    
+        err_image = numpy.zeros(numpy.shape(image))
+        err_image[err_image==0]= 1
+        theory= Data2D(image= image , err_image= err_image)
+        
+        if data ==None:
+            self._fill_default_model2D(theory= theory, qmax=qmax,qstep=qstep, qmin= qmin)
+            theory.name= model.name
+        else:
+            theory.name= data.name
+            theory.id= "Model"
+            theory.group_id= "Model"+data.name
+            theory.x_bins= data.x_bins
+            theory.y_bins= data.y_bins
+            theory.detector= data.detector
+            theory.source= data.source
+            
+            ## plot boundaries
+            theory.ymin= data.ymin
+            theory.ymax= data.ymax
+            theory.xmin= data.xmin
+            theory.xmax= data.xmax
+        
         ## plot
         wx.PostEvent(self.parent, NewPlotEvent(plot=theory,
                          title="Analytical model 2D ", reset=True ))
          
-        
+    def _on_data_error(self, event):
+        """
+            receives and event from plotting plu-gins to store the data name and 
+            their errors of y coordinates for 1Data hide and show error
+        """
+        self.err_dy= event.err_dy
          
-    def _draw_model2D(self,model,description=None, enable2D=False,
+    def _draw_model2D(self,model,data=None,description=None, enable2D=False,
                       qmin=DEFAULT_QMIN, qmax=DEFAULT_QMAX, qstep=DEFAULT_NPTS):
         """
@@ -1140,4 +976,5 @@
             
         """
+        
         x=  numpy.linspace(start= -1*qmax,
                                stop= qmax,
@@ -1148,24 +985,86 @@
                                num= qstep,
                                endpoint=True )
-       
-        self.model= model
-        if enable2D:
-            try:
-                from model_thread import Calc2D
-                ## If a thread is already started, stop it
-                if self.calc_thread != None and self.calc_thread.isrunning():
-                    self.calc_thread.stop()
-                self.calc_thread = Calc2D( x= x,
-                                           y= y, model= self.model, 
-                                           qmin= qmin,
-                                           qmax= qmax,
-                                           qstep= qstep,
-                                completefn= self.complete2D,
-                                updatefn= self.update2D )
-                self.calc_thread.queue()
-                
-            except:
-                raise
-    
+        ## use data info instead
+        if data !=None:
+            ## check if data2D to plot
+            if hasattr(data, "x_bins"):
+                enable2D = True
+                x= data.x_bins
+                y= data.y_bins
+            
+        if not enable2D:
+            return
+        try:
+            from model_thread import Calc2D
+            ## If a thread is already started, stop it
+            if self.calc_2D != None and self.calc_2D.isrunning():
+                self.calc_2D.stop()
+            self.calc_2D = Calc2D(  x= x,
+                                    y= y,
+                                    model= model, 
+                                    data = data,
+                                    qmin= qmin,
+                                    qmax= qmax,
+                                    qstep= qstep,
+                                    completefn= self._complete2D,
+                                    updatefn= self._update2D )
+            self.calc_2D.queue()
+            
+        except:
+            msg= " Error occurred when drawing %s Model 2D: "%model.name
+            msg+= " %s"%sys.exc_value
+            wx.PostEvent( self.parent, StatusEvent(status= msg ))
+            return  
+   
+    def _draw_model1D(self, model, data=None, smearer= None,
+                qmin=DEFAULT_QMIN, qmax=DEFAULT_QMAX, qstep= DEFAULT_NPTS,enable1D= True):
+        """
+            Draw model 1D from loaded data1D
+            @param data: loaded data
+            @param model: the model to plot
+        """
+         
+        x=  numpy.linspace(start= qmin,
+                           stop= qmax,
+                           num= qstep,
+                           endpoint=True
+                           )
+        if data!=None:
+            ## check for data2D
+            if hasattr(data,"x_bins"):
+                return
+            x = data.x
+            if qmin == DEFAULT_QMIN :
+                qmin = min(data.x)
+            if qmax == DEFAULT_QMAX:
+                qmax = max(data.x)
+        
+        if not enable1D:
+            return
+    
+        try:
+            from model_thread import Calc1D
+            ## If a thread is already started, stop it
+            if self.calc_1D!= None and self.calc_1D.isrunning():
+                self.calc_1D.stop()
+            self.calc_1D= Calc1D( x= x,
+                                  data = data,
+                                  model= model, 
+                                  qmin = qmin,
+                                  qmax = qmax,
+                                  smearer = smearer,
+                                  completefn = self._complete1D,
+                                  updatefn = self._update1D  )
+            self.calc_1D.queue()
+            
+        except:
+            msg= " Error occurred when drawing %s Model 1D: "%model.name
+            msg+= " %s"%sys.exc_value
+            wx.PostEvent( self.parent, StatusEvent(status= msg ))
+            return  
+            
+   
+
+
    
 if __name__ == "__main__":
Index: sansview/perspectives/fitting/model_thread.py
===================================================================
--- sansview/perspectives/fitting/model_thread.py	(revision bb18ef1c74ed79eb0630f198735ad2b14e7913ab)
+++ sansview/perspectives/fitting/model_thread.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -90,5 +90,5 @@
     """
     
-    def __init__(self, x, y, model,qmin, qmax,qstep,
+    def __init__(self, x, y, data,model,qmin, qmax,qstep,
                  completefn = None,
                  updatefn   = None,
@@ -101,8 +101,9 @@
                  worktime)
         self.qmin= qmin
-        self.qmax=qmax
+        self.qmax= qmax
         self.qstep= qstep
         self.x = x
         self.y = y
+        self.data= data
         ## the model on to calculate
         self.model = model
@@ -128,13 +129,17 @@
         y = self.y
         output = numpy.zeros((len(x),len(y)))
-      
-        center_x=0
-        center_y=0
+        
+        if self.qmin==None:
+            self.qmin = 0
+        if self.qmax== None:
+            if data ==None:
+                return
+            newx= math.pow(max(math.fabs(data.xmax),math.fabs(data.xmin)),2)
+            newy= math.pow(max(math.fabs(data.ymax),math.fabs(data.ymin)),2)
+            self.qmax=math.sqrt( newx + newy )
         
         self.starttime = time.time()
         
-        
         lx = len(self.x)
-       
         for i_x in range(len(self.x)):
             # Check whether we need to bail out
@@ -143,19 +148,20 @@
        
             for i_y in range(int(len(self.y))):
-           
-                if (self.x[i_x]*self.x[i_x]+self.y[i_y]*self.y[i_y]) \
-                    < self.qmin * self.qmin:
-                    
-                    output[i_x] [i_y]=0   
+                radius = self.x[i_x]*self.x[i_x]+self.y[i_y]*self.y[i_y]
+                
+                if  self.qmin <= radius or radius<= self.qmax:
+                    value = self.model.runXY( [self.x[i_x], self.y[i_y]] )
+                    output[i_x] [i_y]=value   
                 else:
-                    value = self.model.runXY([self.x[i_x]-center_x, self.y[i_y]-center_y])
-                    output[i_x] [i_y]=value   
+                     output[i_x] [i_y]=0   
             
         elapsed = time.time()-self.starttime
-        self.complete(
-                      output=output, elapsed=elapsed,model= self.model,
-                      qmin= self.qmin,
-                      qmax=self.qmax,
-                      qstep=self.qstep)
+        self.complete( image = output,
+                       data = self.data , 
+                       model = self.model,
+                       elapsed = elapsed,
+                       qmin = self.qmin,
+                       qmax =self.qmax,
+                       qstep = self.qstep )
 
 
@@ -256,5 +262,4 @@
                  qmin=None,
                  qmax=None,
-                 name=None,
                  smearer=None,
                  completefn = None,
@@ -272,17 +277,15 @@
         self.qmax= qmax
         self.model = model
-        self.name= name
         self.smearer= smearer
         self.starttime = 0
         
     def compute(self):
+        """
+            Compute model 1d value given qmin , qmax , x value 
+        """
         import numpy
         
         output = numpy.zeros(len(self.x))
-        if self.qmin==None:
-            self.qmin= min(self.x)
-        if self.qmax==None:
-            self.qmax= max(self.x) 
-               
+       
         self.starttime = time.time()
         
@@ -294,10 +297,12 @@
                 value = self.model.run(self.x[i_x])
                 output[i_x] = value
+                
         if self.smearer!=None:
             output = self.smearer(output)
-                    
+            
+                      
         elapsed = time.time()-self.starttime
-        self.complete(x= self.x, output=output, 
-                      elapsed=elapsed, name=self.name, data=self.data)
+        self.complete(x= self.x, y= output, 
+                      elapsed=elapsed, model= self.model, data=self.data)
         
         
